/*
 *  Copyright (C) 2002-2005 Akira Nukada
 *  Copyright (C) 2002-2005 The SSI Project. All rights reserved.
 *  http://ssi.is.s.u-tokyo.ac.jp
 *
 *  This software is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY.  See the COPYING file for the precise
 *  terms and conditions for the use of this software.
 */
#include "libfftss.h"

void fftss_copyin(double *restrict vout, double *vin, long stride, long n)
{
  long i;

  for (i = 0; i < n; i++) {
    vout[2 * i] = vin[2 * i * stride];
    vout[2 * i + 1] = vin[2 * i * stride + 1];
  }
}

void fftss_copyout(double *restrict vout, double *vin, long stride, long n)
{
  long i;

  for (i = 0; i < n; i++) {
    vout[2 * i * stride] = vin[2 * i];
    vout[2 * i * stride + 1] = vin[2 * i + 1];
  }
}
